#include "viewbuttondemo.h"
#include "ui_viewbuttondemo.h"

#include <QPushButton>
#include <QMessageBox>
#include <QDebug>

enum {
    COLUMN_LAST_NAME,
    COLUMN_FIRST_NAME,
    COLUMN_MIDDLE_NAME,
    COLUMN_ACTION
};

ViewButtonDemo::ViewButtonDemo( QWidget* parent ) :
    QWidget( parent ),
    ui( new Ui::ViewButtonDemo ) {
    ui->setupUi( this );

    for( int i = 0; i < ui->tableWidget->rowCount(); ++i ) {
        ui->tableWidget->setIndexWidget(
            ui->tableWidget->model()->index( i, COLUMN_ACTION ),
            createButtonWidget()
        );
    }
}

ViewButtonDemo::~ViewButtonDemo() {
    delete ui;
}

void ViewButtonDemo::onBtnClicked() {
    if( QPushButton* btn = qobject_cast< QPushButton* >( sender() ) ) {
        QModelIndex index = ui->tableWidget->indexAt( btn->parentWidget()->pos() );
        qDebug() << index.row() << "x" << index.column();
        QStringList name;
        for( int i = COLUMN_LAST_NAME; i <= COLUMN_MIDDLE_NAME; ++i ) {
            name << ui->tableWidget->model()->data(
                     ui->tableWidget->model()->index( index.row(), i )
                 ).toString();
        }
        QMessageBox::information( this, "The button was clicked", name.join( " " ) );
    }
}

QWidget* ViewButtonDemo::createButtonWidget() const {
    QWidget* wgt = new QWidget;
    QBoxLayout* l = new QHBoxLayout;
    QPushButton* btn = new QPushButton( "Click me!" );
    connect( btn, SIGNAL( clicked( bool ) ), SLOT( onBtnClicked() ) );
    l->setMargin( 0 );
    l->addWidget( btn );
    l->addStretch();
    wgt->setLayout( l );

    return wgt;
}
